/**
 * @file
 * VuoList_VuoMovieImageEncoding C type definition.
 *
 * @copyright Copyright © 2012–2015 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoMovieImageEncoding_H
#define VuoList_VuoMovieImageEncoding_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoMovieImageEncoding VuoList_VuoMovieImageEncoding
 * A list of @ref VuoMovieImageEncoding elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

#if defined(DOXYGEN) || !defined(VuoList_VuoMovieImageEncoding_TYPE_DEFINED)
/// @{
/**
 * A list of @ref VuoMovieImageEncoding elements.
 */
typedef const struct VuoList_VuoMovieImageEncoding_struct { void *l; } * VuoList_VuoMovieImageEncoding;
/// @}
#endif

/**
 * Creates a new list of @ref VuoMovieImageEncoding elements.
 */
VuoList_VuoMovieImageEncoding VuoListCreate_VuoMovieImageEncoding(void);

/**
 * Makes a shallow copy of `list` — its items are retained (not copied) by the new list.
 */
VuoList_VuoMovieImageEncoding VuoListCopy_VuoMovieImageEncoding(const VuoList_VuoMovieImageEncoding list);

/**
 * Returns the @ref VuoMovieImageEncoding at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoMovieImageEncoding VuoListGetValue_VuoMovieImageEncoding(const VuoList_VuoMovieImageEncoding list, const unsigned long index);

/**
 * Changes the @ref VuoMovieImageEncoding at @c index.
 * Index values start at 1.
 * If the list has no items, nothing is changed.
 * Attempting to change an out-of-bounds index changes the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
void VuoListSetValue_VuoMovieImageEncoding(const VuoList_VuoMovieImageEncoding list, const VuoMovieImageEncoding value, const unsigned long index);

/**
 * Inserts the `VuoMovieImageEncoding` immediately before `index`.
 * Index values start at 1.
 * Inserting at index 0 prepends the value to the list.
 * Inserting at an index beyond the last value in the list appends the value to the list.
 */
void VuoListInsertValue_VuoMovieImageEncoding(const VuoList_VuoMovieImageEncoding list, const VuoMovieImageEncoding value, const unsigned long index);

/**
 * Prepends @c value to @c list.
 */
void VuoListPrependValue_VuoMovieImageEncoding(VuoList_VuoMovieImageEncoding list, const VuoMovieImageEncoding value);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoMovieImageEncoding(VuoList_VuoMovieImageEncoding list, const VuoMovieImageEncoding value);

/**
 * Swaps the value at `indexA` with the value at `indexB`.
 */
void VuoListExchangeValues_VuoMovieImageEncoding(VuoList_VuoMovieImageEncoding list, const unsigned long indexA, const unsigned long indexB);

/**
 * Generates a random permutation of `list`.
 *
 * `chaos` ranges from 0 to 1.  When `chaos` is 1, a full Fisher–Yates shuffle is performed.  When less than 1, fewer iterations are performed.
 */
void VuoListShuffle_VuoMovieImageEncoding(VuoList_VuoMovieImageEncoding list, const double chaos);

/**
 * Reverses the order of the items in `list`.
 */
void VuoListReverse_VuoMovieImageEncoding(VuoList_VuoMovieImageEncoding list);

/**
 * Removes items from the list except those in the range specified by `startIndex` and `itemCount`.
 */
void VuoListCut_VuoMovieImageEncoding(VuoList_VuoMovieImageEncoding list, const signed long startIndex, const unsigned long itemCount);

/**
 * Removes the first value from @c list.
 */
void VuoListRemoveFirstValue_VuoMovieImageEncoding(VuoList_VuoMovieImageEncoding list);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoMovieImageEncoding(VuoList_VuoMovieImageEncoding list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoMovieImageEncoding(VuoList_VuoMovieImageEncoding list);

/**
 * Removes the `VuoMovieImageEncoding` at `index`.
 * Index values start at 1.
 * Attempting to remove index 0 or an index beyond the last value in the list has no effect.
 */
void VuoListRemoveValue_VuoMovieImageEncoding(VuoList_VuoMovieImageEncoding list, const unsigned long index);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoMovieImageEncoding(const VuoList_VuoMovieImageEncoding list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoMovieImageEncoding VuoList_VuoMovieImageEncoding_makeFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoMovieImageEncoding_getJson(const VuoList_VuoMovieImageEncoding value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoMovieImageEncoding_getSummary(const VuoList_VuoMovieImageEncoding value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoMovieImageEncoding VuoList_VuoMovieImageEncoding_makeFromString(const char *str);
char * VuoList_VuoMovieImageEncoding_getString(const VuoList_VuoMovieImageEncoding value);
/// @}

/**
 * @}
 */

#endif
